unit unit_saisie_type_a;

{$mode objfpc}

interface

uses
 UChaines, Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics,
 Dialogs, StdCtrls, ExtCtrls, Buttons, LCLType, Spin, SpecFunx,
 Unit_genere_distribution, MonBitmap, Math, UnitScaleFont, Unit_aidecalcul;

type

  { TForm_saisie_type_a }

  TForm_saisie_type_a = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    CheckBox_serie_plus_longue: TCheckBox;
    Edit_saisie_nombre_mesures: TEdit;
    Edit_saisie_ecart_type: TEdit;
    Edit_saisie_moyenne: TEdit;
    SpeedButton1: TSpeedButton;
    SpinEdit_serie_plus_longue: TSpinEdit;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    procedure BitBtn1Click(Sender: TObject);
    procedure Edit_saisie_ecart_typeKeyPress(Sender: TObject; var Key: char);
    procedure Edit_saisie_moyenneKeyPress(Sender: TObject; var Key: char);
    procedure Edit_saisie_nombre_mesuresKeyPress(Sender: TObject; var Key: char
      );
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private   encreation:boolean;
    { private declarations }
  public
    { public declarations }
  end;

var
  Form_saisie_type_a: TForm_saisie_type_a;

implementation
  uses Unit1;
{ TForm_saisie_type_a }

procedure TForm_saisie_type_a.FormShow(Sender: TObject);
begin
  // if encreation then begin scalefont(self); encreation:=false; end;
   Edit_saisie_moyenne.SetFocus;
end;

procedure TForm_saisie_type_a.BitBtn1Click(Sender: TObject);
var r_1,r_2:extended;r_3:integer;
 begin
    try
  r_1:=strtofloat(Edit_saisie_moyenne.text);
  except
    application.messagebox(pchar(rsValeurDeLaMo2), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;

    try
  r_2:=strtofloat(Edit_saisie_ecart_type.text);
  except
    application.messagebox(pchar(rsValeurDeLCar5), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;

  if r_2=0 then begin
  application.messagebox(pchar(rsValeurDeLInc11), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;


   try
  r_3:=strtoint(Edit_saisie_nombre_mesures.text);
  except
    application.messagebox(pchar(rsValeurDuNomb2), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;

  if r_3<2 then begin
  application.messagebox(pchar(rsLeNombreDeMe), pchar(rsAttention2), mb_ok);
    self.ModalResult:=mrnone;
    exit;
    end;

  liste_distributions[indice_distribution-1].degres_de_liberte:=r_3-1;
    liste_distributions[indice_distribution-1].degres_de_liberte_effectif:=r_3-1;
    liste_distributions[indice_distribution-1].moyenne:=0;
    liste_mesurandes[indice_mesurande].estimateur:=r_1;
    if  liste_distributions[indice_distribution-1].defini_par=par_ecart_type_echantionnal then begin
         liste_distributions[indice_distribution-1].ecart_type_echantionnal:=abs(r_2);
  liste_distributions[indice_distribution-1].incertitude_type:=abs(r_2)/sqrt(1+liste_distributions[indice_distribution-1].degres_de_liberte);
  liste_distributions[indice_distribution-1].pourcentage:=95;
  liste_distributions[indice_distribution-1].incertitude_elargie:=liste_distributions[indice_distribution-1].incertitude_type*
  abs(t_invx(liste_distributions[indice_distribution-1].degres_de_liberte,(1-0.95)/2));
  if checkbox_serie_plus_longue.Checked then
  liste_distributions[indice_distribution-1].degres_de_liberte_effectif:=spinedit_serie_plus_longue.Value-1;
           end;

  if  liste_distributions[indice_distribution-1].defini_par=par_incertitude_type then begin
          liste_distributions[indice_distribution-1].incertitude_type:=abs(r_2);
  liste_distributions[indice_distribution-1].ecart_type_echantionnal:=r_2*sqrt(1+liste_distributions[indice_distribution-1].degres_de_liberte);
  liste_distributions[indice_distribution-1].pourcentage:=95;
  liste_distributions[indice_distribution-1].incertitude_elargie:=liste_distributions[indice_distribution-1].incertitude_type*
  abs(t_invx(liste_distributions[indice_distribution-1].degres_de_liberte,(1-0.95)/2));
          end;

   if  liste_distributions[indice_distribution-1].defini_par=par_incertitude_elargie then begin
          liste_distributions[indice_distribution-1].incertitude_elargie:=abs(r_2);
      liste_distributions[indice_distribution-1].incertitude_type:=liste_distributions[indice_distribution-1].incertitude_elargie/
  abs(t_invx(liste_distributions[indice_distribution-1].degres_de_liberte,(1-liste_distributions[indice_distribution-1].pourcentage/100)/2));
  liste_distributions[indice_distribution-1].ecart_type_echantionnal:=liste_distributions[indice_distribution-1].incertitude_type*sqrt(1+liste_distributions[indice_distribution-1].degres_de_liberte);
                  end;



   if saisie_mesures_effectuee then begin
  liste_distributions[indice_distribution-1].student_nombre_mesures:=_nombre_mesures;
  setlength(liste_distributions[indice_distribution-1].student_liste_mesures,_nombre_mesures);
  for i:=1 to _nombre_mesures do
  liste_distributions[indice_distribution-1].student_liste_mesures[i-1]:=_liste_mesures_correctes[i-1];
  end else
  begin
  liste_distributions[indice_distribution-1].student_nombre_mesures:=0;
  setlength(liste_distributions[indice_distribution-1].student_liste_mesures,_nombre_mesures);
  end;
end;

procedure TForm_saisie_type_a.Edit_saisie_ecart_typeKeyPress(Sender: TObject;
  var Key: char);
begin
   if key=',' then key:='.';
end;

procedure TForm_saisie_type_a.Edit_saisie_moyenneKeyPress(Sender: TObject;
  var Key: char);
begin
   if key=',' then key:='.';
end;

procedure TForm_saisie_type_a.Edit_saisie_nombre_mesuresKeyPress(
  Sender: TObject; var Key: char);
begin
   if key=',' then key:='.';
end;

procedure TForm_saisie_type_a.FormCreate(Sender: TObject);
begin
  encreation:=true;
  StaticText1.Caption:=rsMoyennesDesM;
   StaticText2.Caption:=rsEcartTypeCha4;
   StaticText2.Caption:=rsNombreDeMesu2;
   SpeedButton1.Caption:=rsSaisieOuModi;
   statictext4.Caption:=rsSiLCartTypeE;
   statictext5.Caption:=rsVotreProfess;
end;

procedure TForm_saisie_type_a.SpeedButton1Click(Sender: TObject);
var repmode:integer;
begin
  with Form_aidecalcul do begin
 if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
end;
  repmode:=Form_aidecalcul.ShowModal;
  if ((repmode=mrok) and (_nombre_mesures>1)) then
     begin


    Edit_saisie_moyenne.Text:=floattostr(_moyenne);
    Edit_saisie_nombre_mesures.Text:=inttostr(_nombre_mesures);
    Edit_saisie_nombre_mesures.Text:=inttostr(_nombre_mesures);
    if liste_distributions[indice_distribution-1].defini_par=par_ecart_type_echantionnal  then
    Edit_saisie_ecart_type.Text:=floattostr(_ecart_type);


    if liste_distributions[indice_distribution-1].defini_par=par_incertitude_type  then
    Edit_saisie_ecart_type.Text:=floattostr(abs(_ecart_type)/sqrt(_nombre_mesures));

     if liste_distributions[indice_distribution-1].defini_par=par_incertitude_elargie  then
    Edit_saisie_ecart_type.Text:=floattostr(_ecart_type/
  abs(t_invx(_nombre_mesures-1,(1-liste_distributions[indice_distribution-1].pourcentage/100)/2)));

     end;

end;

initialization
  {$I unit_saisie_type_a.lrs}

end.

