unit Unit_aidecalcul;

{$mode objfpc}

interface

uses
   UChaines,Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, Grids, ComCtrls, Buttons, Menus, Symbolic,Math,UnitScaleFont,
    LCLType,LazHelpHTML,UTF8Process;

type

  { TForm_aidecalcul }

  TForm_aidecalcul = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    StaticText_nombrevaleurs: TStaticText;
    StaticText_ecarttype: TStaticText;
    StaticText_moyenne: TStaticText;
    StringGrid1: TStringGrid;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure StringGrid1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ReCalcule(Sender: TObject);
  private    encreation:boolean;
    { private declarations }
  public
    { public declarations }
  end;

var
  Form_aidecalcul: TForm_aidecalcul;
  _moyenne,_ecart_type:extended;
        _nombre_mesures:integer;   _nombre_valeurs_incorrectes:integer;
        _liste_mesures_correctes:array of extended;   saisie_mesures_effectuee:boolean;
implementation

{ TForm_aidecalcul }

procedure TForm_aidecalcul.ReCalcule(Sender: TObject);
 var i:integer;  valeur_correcte:boolean;  y:extended;
begin
 _nombre_mesures:=0;   _nombre_valeurs_incorrectes:=0;
 _moyenne:=0;
 _ecart_type:=0;
 if stringgrid1.RowCount=1 then exit;
 for i:=1 to stringgrid1.RowCount-1 do
 if  stringgrid1.Cells[1,i]<>''then
 begin
 valeur_correcte:=true;
 try
  y:=strtofloat(stringgrid1.Cells[1,i]);
   except
   valeur_correcte:=false;
   end;
   if valeur_correcte then begin
   inc(_nombre_mesures);
   setlength(_liste_mesures_correctes,_nombre_mesures);
   _liste_mesures_correctes[_nombre_mesures-1]:=y;
   end else inc(_nombre_valeurs_incorrectes);
 end;

 if _nombre_mesures=0 then begin
 statictext_moyenne.Caption:=rsNonCalculabl;
 statictext_ecarttype.Caption:=rsNonCalculabl;
 StaticText_nombrevaleurs.Caption:='0';
 exit;
 end;

 if _nombre_mesures=1 then begin
 _moyenne:=_liste_mesures_correctes[0];
 statictext_moyenne.Caption:=floattostr(_moyenne);
 statictext_ecarttype.Caption:=rsNonCalculabl;
 StaticText_nombrevaleurs.Caption:='1';
 exit;
 end;

 for i:=1 to _nombre_mesures do _moyenne:=_moyenne+_liste_mesures_correctes[i-1];
 _moyenne:=_moyenne/_nombre_mesures;

 for i:=1 to _nombre_mesures do _ecart_type:=_ecart_type+sqr(_liste_mesures_correctes[i-1]-_moyenne);
 _ecart_type:=sqrt(_ecart_type/(_nombre_mesures-1));
   statictext_moyenne.Caption:=floattostr(_moyenne);
 statictext_ecarttype.Caption:=floattostr(_ecart_type);
 StaticText_nombrevaleurs.Caption:=inttostr(_nombre_mesures);
end;


procedure TForm_aidecalcul.FormCreate(Sender: TObject);
begin
  encreation:=true;

  CAPTION:=rsAideAuCalcul;
STATICTEXT1.CAPTION:=rsDansLeCasDeN;
STATICTEXT2.CAPTION:=rsMoyenne;
STATICTEXT_MOYENNE.CAPTION:=rsStaticText_m;
STATICTEXT3.CAPTION:=rsEcartTypeCha3;
STATICTEXT_ECARTTYPE.CAPTION:=rsEcartTypeCha3;
BITBTN1.CAPTION:=rsValiderEtRep;
BITBTN2.CAPTION:=rsAnnuler;
STATICTEXT4.CAPTION:=rsEtDeLCartTyp;
SPEEDBUTTON1.CAPTION:=rsCalculer;
STATICTEXT5.CAPTION:=rsNombreDeVale;
STATICTEXT_NOMBREVALEURS.CAPTION:=rsNombreDeVale;
SPEEDBUTTON2.CAPTION:=rsSupprimerLig;


  stringgrid1.Cells[1, 0]:=rsMesures;
  stringgrid1.RowCount:=2;
   stringgrid1.Cells[0,1]:='1';
   statictext_moyenne.Caption:='';
 statictext_ecarttype.Caption:='';
 StaticText_nombrevaleurs.Caption:='';
end;

procedure TForm_aidecalcul.BitBtn1Click(Sender: TObject);
begin
 ReCalcule(Sender);
 saisie_mesures_effectuee:= (_nombre_mesures>=2);
end;

procedure TForm_aidecalcul.BitBtn2Click(Sender: TObject);
begin
 ReCalcule(Sender);
 saisie_mesures_effectuee:= (_nombre_mesures>=2);
end;

procedure TForm_aidecalcul.FormShow(Sender: TObject);
begin
 // if encreation then begin scalefont(self); encreation:=false; end;
end;

procedure TForm_aidecalcul.SpeedButton1Click(Sender: TObject);
begin
  ReCalcule(Sender);
end;

procedure TForm_aidecalcul.SpeedButton2Click(Sender: TObject);
var r,i:integer;
begin
  r:=stringgrid1.Row;
  if r>1 then stringgrid1.DeleteColRow(false,r);
  for i:=r to stringgrid1.RowCount-1 do stringgrid1.Cells[0,i]:=inttostr(i);
  ReCalcule(Sender);
end;

procedure TForm_aidecalcul.StringGrid1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);

  Var
    R, C : integer ;
   begin
    C := StringGrid1.Col ;
        R := StringGrid1.Row;


    case Key of
      VK_RETURN, VK_TAB :
      begin

        if (R = StringGrid1.RowCount-1) and (C = 1) and (StringGrid1.Cells[1,R]<>'') then
        begin
          Key := VK_Unknown ;
          try
          strtofloat(StringGrid1.Cells[1,R]);
          except
            application.MessageBox(pchar(Format(rsEstUneValeur, [
              StringGrid1.Cells[1, R]])),pchar( rsAttention2), mrok);
            exit;
          end;
          StringGrid1.RowCount := StringGrid1.RowCount+1 ;
          StringGrid1.Col := 1 ;
          StringGrid1.Row := R+1 ;
          StringGrid1.Cells[0,R+1]:=inttostr(R+1);
        end;

        if (R < StringGrid1.RowCount-1) and (C = 1)  and (StringGrid1.Cells[1,R]<>'') then
        begin
         // Key := VK_Unknown ;
          try
          strtofloat(StringGrid1.Cells[1,R]);
          except
            application.MessageBox(pchar(Format(rsEstUneValeur, [
              StringGrid1.Cells[1, R]])),  pchar( rsAttention2), mrok);
            exit;
          end;
                   end;
      end;
     VK_UP,VK_DOWN:
     begin
     if  (C = 1)  and (StringGrid1.Cells[1,R]<>'') then
        begin
         // Key := VK_Unknown ;
          try
          strtofloat(StringGrid1.Cells[1,R]);
          except
            application.MessageBox(pchar(Format(rsEstUneValeur, [
              StringGrid1.Cells[1, R]])),  pchar( rsAttention2), mrok);
            exit;
          end;    end;

     end;

    end; {du case}
    ReCalcule(Sender);
  end;

initialization
  {$I unit_aidecalcul.lrs}

end.

